package mvc.interfaces;

/**
 * Classes that implementes this interface should play
 * the role of the Model in the Model-View-Controller design pattern.
 * The Model is the domain-specific representation of the information
 * on which the application operates.
 */
public interface IModel
{
	/**
	 * Sets the model's state.
	 * 
	 * @param aState - the state to set into
	 */
	public void setState(int aState);


	/**
	 * Returns the current state.
	 * 
	 * @return the current state.
	 */
	public int getState();
}
