//  The file MSDCoordinatorAspect.aj was automatically generated using S2A 0.2 beta.
//	 Usage of the generated code is permitted for non-commercial research and evaluation purposes..
//	 Removing or changing the above comment is prohibited by S2A 0.2 beta license agreement.
//	 For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package phonebook.aspects;

import mvc.interfaces.*;
import phonebook.view.simple.*;
import phonebook.*;
import phonebook.model.*;
import javax.swing.*;
import phonebook.view.extended.*;
import msd.runtime.lib.*;


public aspect MSDCoordinatorAspect
{
	declare precedence: MSDCoordinatorAspect, *;
	ICoordinatorStrategy strategy = new CoordinatorStrategyNaiveImpl();

	private boolean lock = false;
	private int counter = 0;

	public void PanelControl.WrappersetEnabled(JButton jButton,Boolean exact_b2)
	{
		jButton.setEnabled(exact_b2);
	}

	public void ExtendedViewController.WrapperuserHasInput(PhoneBookController phoneBookController,String symbolic_input)
	{
		phoneBookController.userHasInput(symbolic_input);
	}

	public void ModelControll.WrappercloseConnection(DBConnector dBConnector)
	{
		dBConnector.closeConnection();
	}

	public void ExtendedViewController.WrapperchangeView(MessagePane messagePane,Integer symbolic_state)
	{
		messagePane.changeView(symbolic_state);
	}

	public void ModelControll.WrapperstateHasChanged(ExtendedViewController extendedViewController,Integer symbolic_state)
	{
		extendedViewController.stateHasChanged(symbolic_state);
	}

	public void PhoneBookController.WrapperaddAnEntry(PhoneBookModel phoneBookModel,String symbolic_input)
	{
		phoneBookModel.addAnEntry(symbolic_input);
	}

	public void PhoneBookController.WrappersaveAll(PhoneBookModel phoneBookModel)
	{
		phoneBookModel.saveAll();
	}

	public void PanelControl.WrappersetAddButtonState(PanelControl panelControl,Integer symbolic_state)
	{
		panelControl.setAddButtonState(symbolic_state);
	}

	public void ExtendedViewController.WrappercheckForEnabled(ExtendedInputPane extendedInputPane,Integer symbolic_state)
	{
		extendedInputPane.checkForEnabled(symbolic_state);
	}

	public void ExtendedInputPane.WrapperprocessInput(ExtendedViewController extendedViewController)
	{
		extendedViewController.processInput();
	}

	public void PanelControl.WrapperprocessInput(ExtendedViewController extendedViewController)
	{
		extendedViewController.processInput();
	}

	public void PhoneBookController.WrappersetState(PhoneBookModel phoneBookModel,Integer exact_sNine16)
	{
		phoneBookModel.setState(exact_sNine16);
	}

	public void PhoneBookController.WrappersearchPhoneNumber(PhoneBookModel phoneBookModel,String symbolic_input)
	{
		phoneBookModel.searchPhoneNumber(symbolic_input);
	}

	public void PhoneBookController.WrappersetName(PhoneBookModel phoneBookModel,String symbolic_input)
	{
		phoneBookModel.setName(symbolic_input);
	}

	public void ExtendedViewController.Wrapperclear(ResultPane resultPane)
	{
		resultPane.clear();
	}

	public void ExtendedViewController.Wrapperclear(MessagePane messagePane)
	{
		messagePane.clear();
	}

	public void ModelControll.WrapperstandBy(DBConnector dBConnector)
	{
		dBConnector.standBy();
	}

	public void ExtendedViewController.WrapperarrangeEnabledButtons(PanelControl panelControl,Integer symbolic_state)
	{
		panelControl.arrangeEnabledButtons(symbolic_state);
	}

	public void ExtendedViewController.WrapperprintResults(ResultPane resultPane,Integer symbolic_state)
	{
		resultPane.printResults(symbolic_state);
	}

	pointcut MSDMessage():
	call(void *.searchPhoneNumber(..))
	|| call(void *.addAnEntry(..))
	|| execution(void *.actionPerformed(..))
	|| call(void *.printResults(..))
	|| call(void *.closeConnection(..))
	|| execution(void *.setLastInput(..))
	|| call(void *.setState(..))
	|| call(void *.dbStandsBy(..))
	|| call(void *.checkForEnabled(..))
	|| call(void *.dbIsClosed(..))
	|| call(void *.changeView(..))
	|| call(void *.saveAll(..))
	|| execution(void *.setAddButtonState(..))
	|| call(void *.processInput(..))
	|| call(void *.userHasInput(..))
	|| call(void *.stateHasChanged(..))
	|| call(void *.setEnabled(..))
	|| call(void *.arrangeEnabledButtons(..))
	|| call(void *.setName(..))
	|| call(void *.clear(..))
	|| call(void *.standBy(..));


	after (): MSDMessage()
	{
		MSDAspect.handlingEvent(thisJoinPoint);
		coordinate();
	}

	private void coordinate()
	{
		if (lock)
		{
			counter++;
			return;
		}
		else
		{
			lock = true;
			afterImpl();
			lock = false;
		}
		if(counter>0)
		{
			counter--;
			coordinate();
		}
	}

	private void afterImpl() 
	{
		MSDMethodSet monitoringEnabled = new MSDMethodSet();
		MSDMethodSet executingEnabled = new MSDMethodSet();
		MSDMethodSet coldViolation = new MSDMethodSet();
		MSDMethodSet hotViolation = new MSDMethodSet();

		MSDAspectMVCAbstract.aspectOf().getCutState(monitoringEnabled, executingEnabled, coldViolation, hotViolation);
		MSDAspectUserInput.aspectOf().getCutState(monitoringEnabled, executingEnabled, coldViolation, hotViolation);

		MSDMethod MSDm = strategy.chooseMethod(monitoringEnabled, executingEnabled, coldViolation, hotViolation);

		if(MSDm != null)
		{
			switch (MSDm.messageID)
			{
				case MSDMethods.PanelControl_JButton_setEnabled:
				 ((PanelControl)MSDm.sourceInstance).WrappersetEnabled(
					(JButton)MSDm.targetInstance
					,(Boolean)MSDm.args.get(0));
				break;
				case MSDMethods.ExtendedViewController_PhoneBookController_userHasInput:
				 ((ExtendedViewController)MSDm.sourceInstance).WrapperuserHasInput(
					(PhoneBookController)MSDm.targetInstance
					,(String)MSDm.args.get(0));
				break;
				case MSDMethods.ModelControll_DBConnector_closeConnection:
				 ((ModelControll)MSDm.sourceInstance).WrappercloseConnection(
					(DBConnector)MSDm.targetInstance);
				break;
				case MSDMethods.ExtendedViewController_MessagePane_changeView:
				 ((ExtendedViewController)MSDm.sourceInstance).WrapperchangeView(
					(MessagePane)MSDm.targetInstance
					,(Integer)MSDm.args.get(0));
				break;
				case MSDMethods.ModelControll_ExtendedViewController_stateHasChanged:
				 ((ModelControll)MSDm.sourceInstance).WrapperstateHasChanged(
					(ExtendedViewController)MSDm.targetInstance
					,(Integer)MSDm.args.get(0));
				break;
				case MSDMethods.PhoneBookController_PhoneBookModel_addAnEntry:
				 ((PhoneBookController)MSDm.sourceInstance).WrapperaddAnEntry(
					(PhoneBookModel)MSDm.targetInstance
					,(String)MSDm.args.get(0));
				break;
				case MSDMethods.PhoneBookController_PhoneBookModel_saveAll:
				 ((PhoneBookController)MSDm.sourceInstance).WrappersaveAll(
					(PhoneBookModel)MSDm.targetInstance);
				break;
				case MSDMethods.PanelControl_PanelControl_setAddButtonState:
				 ((PanelControl)MSDm.sourceInstance).WrappersetAddButtonState(
					(PanelControl)MSDm.targetInstance
					,(Integer)MSDm.args.get(0));
				break;
				case MSDMethods.ExtendedViewController_ExtendedInputPane_checkForEnabled:
				 ((ExtendedViewController)MSDm.sourceInstance).WrappercheckForEnabled(
					(ExtendedInputPane)MSDm.targetInstance
					,(Integer)MSDm.args.get(0));
				break;
				case MSDMethods.ExtendedInputPane_ExtendedViewController_processInput:
				 ((ExtendedInputPane)MSDm.sourceInstance).WrapperprocessInput(
					(ExtendedViewController)MSDm.targetInstance);
				break;
				case MSDMethods.PanelControl_ExtendedViewController_processInput:
				 ((PanelControl)MSDm.sourceInstance).WrapperprocessInput(
					(ExtendedViewController)MSDm.targetInstance);
				break;
				case MSDMethods.PhoneBookController_PhoneBookModel_setState:
				 ((PhoneBookController)MSDm.sourceInstance).WrappersetState(
					(PhoneBookModel)MSDm.targetInstance
					,(Integer)MSDm.args.get(0));
				break;
				case MSDMethods.PhoneBookController_PhoneBookModel_searchPhoneNumber:
				 ((PhoneBookController)MSDm.sourceInstance).WrappersearchPhoneNumber(
					(PhoneBookModel)MSDm.targetInstance
					,(String)MSDm.args.get(0));
				break;
				case MSDMethods.PhoneBookController_PhoneBookModel_setName:
				 ((PhoneBookController)MSDm.sourceInstance).WrappersetName(
					(PhoneBookModel)MSDm.targetInstance
					,(String)MSDm.args.get(0));
				break;
				case MSDMethods.ExtendedViewController_ResultPane_clear:
				 ((ExtendedViewController)MSDm.sourceInstance).Wrapperclear(
					(ResultPane)MSDm.targetInstance);
				break;
				case MSDMethods.ExtendedViewController_MessagePane_clear:
				 ((ExtendedViewController)MSDm.sourceInstance).Wrapperclear(
					(MessagePane)MSDm.targetInstance);
				break;
				case MSDMethods.ModelControll_DBConnector_standBy:
				 ((ModelControll)MSDm.sourceInstance).WrapperstandBy(
					(DBConnector)MSDm.targetInstance);
				break;
				case MSDMethods.ExtendedViewController_PanelControl_arrangeEnabledButtons:
				 ((ExtendedViewController)MSDm.sourceInstance).WrapperarrangeEnabledButtons(
					(PanelControl)MSDm.targetInstance
					,(Integer)MSDm.args.get(0));
				break;
				case MSDMethods.ExtendedViewController_ResultPane_printResults:
				 ((ExtendedViewController)MSDm.sourceInstance).WrapperprintResults(
					(ResultPane)MSDm.targetInstance
					,(Integer)MSDm.args.get(0));
				break;
			}
		}
	}
}

